; ------------- READS51 generated header -------------- 
; module  : D:\Arbeit\Flash\Reads51\Work\send_d\send_D.asm
; created : 17:38:20, Wednesday, October 06, 2004
; ----------------------------------------------------- 
;Serial port access       (COMPORT.ASM)
;11,059MHz, 9600 Baud
 

; Laden mit Microflash.exe via COM1 an Athlon 78666 (21.12.2004)

#include <sfr51.inc>


DQ  equ  P3_5   ;Port 3.5
CLK equ  P3_4   ;Port 3.4
RST equ  P3_3   ;Port 3.3

        

        
        ajmp start

        
        org 03H
        ljmp isr0
        ; org 13H
        ; ljmp isr1

        
        org 100H




;----------------------
initialize:
            MOV TH1,#0FDH
          ;  MOV TL1,#0FDH   ;??????
            MOV PCON,#00000000B
            MOV SCON,#50h
            MOV TMOD,#00100001B
            MOV TCON,#01000000B
            RET
;----------------------
delayMS:    push acc
            MOV R7,#0
loopa:      inc R7
            MOV a,R7
            CJNE a,#0FFH,loopa
            pop acc
            ret
;----------------------
delay10MS:  push acc
            mov R6,#10
loop10:     acall delayMS
            djnz R6,loop10
            pop acc
            ret
;----------------------
delays:     push acc
            MOV R6,#0
            MOV R5,#004H
loopb:      inc R6
            acall delayms
            MOV a,R6
            JNZ loopb
            dec R5
            Mov acc,R5
            JNZ loopb
            pop acc
            ret

;----------------------
send:       clr TI
            MOV sbuf,a
wait:       jnb TI,wait
            ret

;----------------------
write1620:  MOV R0,#08H
           
Nextbitwrite:

            clr CLK
            rrc a
            mov DQ,C
            setb CLK   ; rising edge puts data into 1620
            djnz R0,Nextbitwrite
            setb DQ
            ret

;----------------------
Read1620:   setb DQ   ; DQ auf jeden Fall als Input schalten
            mov R0,#08H
            
Nextbitread:
            
            clr CLK   ; falling edge: 1620 has valid data on DQ after 150 ns
            nop       ; vorsichtshalber, sollte nicht ntig sein
            mov c,DQ
            rrc a
            setb clk  ; rising edge: Data from 1620 no longer valid
            
            djnz R0,Nextbitread 
            ret       ; a sollte jetzt 8 bit Daten enthalten  
;----------------------
configure:  setb RST
            mov a,#00CH
            acall write1620
            acall delay10ms
            mov a,#00000011B  ; CPU and 1Shot
            acall write1620
            clr RST
            ret
;----------------------
write_TL:   setb RST
            mov a,#02H
            acall write1620
            mov a,#0FH
            acall write1620
            clr RST
            ret
;----------------------
read_TL:    setb RST
            mov a,#A2H
            acall write1620
            acall read1620
            clr RST
            ret
;----------------------
start_convert:
            setb RST
            MOV a,#0EEH
            acall write1620
            clr RST 
            ret
;----------------------
read_config:
            setb RST
            mov a,#0ACh   ; issue read config command 
            acall write1620
            acall delay10ms
            acall read1620
            clr RST
            ret
;----------------------
read_temperature:
            setb RST
            MOV a,#0AAH
            acall write1620
            nop
            acall Read1620
            mov R1,a
            acall Read1620
            mov R2,a
            clr RST
            ret
;---------------------- 
start:    ;  MOV SP,#30H
          ;  mov a,#00000001b   ; LED1 aus
          ;  mov P1_0,a
            acall initialize
            setb CLK
            setb RST
            clr RST    ; negative Flanke an RST whrend CLK=Hi
            
            setb DQ    ; DQ auf jeden Fall als Input schalten
            acall configure
           ; acall write_TL
           ; acall start_convert
            acall delay10ms
            
            ;acall read_TL
            
            acall read_config 
            
            ; acall read_temperature
            acall send



loop:      ; acall start_convert
            
           ; acall delays
           ; acall read_Temperature
           ; mov a,R1
           ; acall send
           ; mov a,R2
           ; acall send
loop1:            ajmp loop1



isr0:       mov a,#00000000b
            mov P1_0,a
            reti
end
